Package org.apache.catalina.filters

## Class SessionInitializerFilter

- java.lang.Object
- - org.apache.catalina.filters.SessionInitializerFilter

All Implemented Interfaces:
  `Filter`

    public class SessionInitializerFilter
    extends java.lang.Object
    implements Filter

A `Filter` that initializes the `HttpSession` for the `HttpServletRequest` by calling its getSession() method.

This is required for some operations with WebSocket requests, where it is too late to initialize the HttpSession object, and the current Java WebSocket specification does not provide a way to do so.

### Constructor Summary

Constructors
`SessionInitializerFilter()`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `destroy()` Called by the web container to indicate to a filter that it is being taken out of service.
`void` `doFilter​(ServletRequest request, ServletResponse response, FilterChain chain)` Calls `HttpServletRequest`'s getSession() to initialize the HttpSession and continues processing the chain.
`void` `init​(FilterConfig filterConfig)` Called by the web container to indicate to a filter that it is being placed into service.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### SessionInitializerFilter

    public SessionInitializerFilter()

### Method Detail

#### doFilter

    public void doFilter​(ServletRequest request,
                         ServletResponse response,
                         FilterChain chain)
                  throws java.io.IOException,
                         ServletException

Calls `HttpServletRequest`'s getSession() to initialize the HttpSession and continues processing the chain.

Specified by:
  `doFilter` in interface `Filter`
Parameters:
  `request` - The request to process
  `response` - The response associated with the request
  `chain` - Provides access to the next filter in the chain for this filter to pass the request and response to for further processing
Throws:
  `java.io.IOException` - if an I/O error occurs during this filter's processing of the request
  `ServletException` - if the processing fails for any other reason

#### init

    public void init​(FilterConfig filterConfig)
              throws ServletException

Description copied from interface: `javax.servlet.Filter`
Called by the web container to indicate to a filter that it is being placed into service. The servlet container calls the init method exactly once after instantiating the filter. The init method must complete successfully before the filter is asked to do any filtering work.

The web container cannot place the filter into service if the init method either:

- Throws a ServletException
- Does not return within a time period defined by the web container

Specified by:
  `init` in interface `Filter`
Parameters:
  `filterConfig` - The configuration information associated with the filter instance being initialised
Throws:
  `ServletException` - if the initialisation fails

#### destroy

    public void destroy()

Description copied from interface: `javax.servlet.Filter`
Called by the web container to indicate to a filter that it is being taken out of service. This method is only called once all threads within the filter's doFilter method have exited or after a timeout period has passed. After the web container calls this method, it will not call the doFilter method again on this instance of the filter.
This method gives the filter an opportunity to clean up any resources that are being held (for example, memory, file handles, threads) and make sure that any persistent state is synchronized with the filter's current state in memory.

Specified by:
  `destroy` in interface `Filter`